# wxPen Class Reference
[Graphics Device Interface (GDI)]

`#include <wx/pen.h>`

Inheritance diagram for wxPen:
[legend]

## Detailed Description

A pen is a drawing tool for drawing outlines.

It is used for drawing lines and painting the outline of rectangles, ellipses, etc. It has a colour, a width and a style.

Note:
  On a monochrome display, wxWidgets shows all non-white pens as black.

Do not initialize objects on the stack before the program commences, since other required structures may not have been set up yet. Instead, define global pointers to objects and create them in wxApp::OnInit() or when required.

An application may wish to dynamically create pens with different characteristics, and there is the consequent danger that a large number of duplicate pens will be created. Therefore an application may wish to get a pointer to a pen by using the global list of pens wxThePenList, and calling the member function wxPenList::FindOrCreatePen(). See wxPenList for more info.

This class uses reference counting and copy-on-write internally so that assignments between two instances of this class are very cheap. You can therefore use actual objects instead of pointers without efficiency problems. If an instance of this class is changed it will create its own data internally so that other instances, which previously shared the data using the reference counting, are not affected.

##

Library: wxCore

Category: Graphics Device Interface (GDI)

Predefined objects/pointers:

- wxNullPen
- wxBLACK_DASHED_PEN
- wxBLACK_PEN
- wxBLUE_PEN
- wxCYAN_PEN
- wxGREEN_PEN
- wxYELLOW_PEN
- wxGREY_PEN
- wxLIGHT_GREY_PEN
- wxMEDIUM_GREY_PEN
- wxRED_PEN
- wxTRANSPARENT_PEN
- wxWHITE_PEN

See also:
  wxPenList, wxDC, wxDC::SetPen()

## Public Member Functions
| wxPen ()
| Default constructor.
| wxPen (const wxColour &colour, int width=1, wxPenStyle style=wxPENSTYLE_SOLID)
| Constructs a pen from a colour object, pen width and style.
| wxPen (const wxBitmap &stipple, int width)
| Constructs a stippled pen from a stipple bitmap and a width.
| wxPen (const wxPen &pen)
| Copy constructor, uses Reference Counting.
virtual | ~wxPen ()
| Destructor.
virtual wxPenCap | GetCap () const
| Returns the pen cap style, which may be one of `wxCAP_ROUND`, `wxCAP_PROJECTING` and `wxCAP_BUTT`.
virtual wxColour | GetColour () const
| Returns a reference to the pen colour.
virtual int | GetDashes (wxDash **dashes) const
| Gets an array of dashes (defined as `char` in X, `DWORD` under Windows).
virtual wxPenJoin | GetJoin () const
| Returns the pen join style, which may be one of `wxJOIN_BEVEL`, `wxJOIN_ROUND` and `wxJOIN_MITER`.
virtual wxBitmap * | GetStipple () const
| Gets a pointer to the stipple bitmap.
virtual wxPenStyle | GetStyle () const
| Returns the pen style.
virtual int | GetWidth () const
| Returns the pen width.
virtual bool | IsOk () const
| Returns true if the pen is initialised.
bool | IsNonTransparent () const
| Returns true if the pen is a valid non-transparent pen.
bool | IsTransparent () const
| Returns true if the pen is transparent.
virtual void | SetCap (wxPenCap capStyle)
| Sets the pen cap style, which may be one of `wxCAP_ROUND`, `wxCAP_PROJECTING` and `wxCAP_BUTT`.
virtual void | SetDashes (int n, const wxDash *dash)
| Associates an array of pointers to dashes (defined as `char` in X, `DWORD` under Windows) with the pen.
virtual void | SetJoin (wxPenJoin join_style)
| Sets the pen join style, which may be one of `wxJOIN_BEVEL`, `wxJOIN_ROUND` and `wxJOIN_MITER`.
virtual void | SetStipple (const wxBitmap &stipple)
| Sets the bitmap for stippling.
virtual void | SetStyle (wxPenStyle style)
| Set the pen style.
virtual void | SetWidth (int width)
| Sets the pen width.
bool | operator!= (const wxPen &pen) const
| Inequality operator.
wxPen & | operator= (const wxPen &pen)
| Assignment operator, using Reference Counting.
bool | operator== (const wxPen &pen) const
| Equality operator.
virtual void | SetColour (wxColour &colour)
| The pen's colour is changed to the given colour.
virtual void | SetColour (unsigned char red, unsigned char green, unsigned char blue)
| The pen's colour is changed to the given colour.

List of all members.

## Constructor & Destructor Documentation

wxPen::wxPen | ( |  | ) |

Default constructor.

The pen will be uninitialised, and IsOk() will return false.

wxPen::wxPen | ( | const wxColour & | colour,
|  | int | width = `1`,
|  | wxPenStyle | style = `wxPENSTYLE_SOLID` |
| ) |  |  |

Constructs a pen from a colour object, pen width and style.

Parameters:

  | colour | A colour object.
  | width | Pen width. Under Windows, the pen width cannot be greater than 1 if the style is `wxPENSTYLE_DOT`, `wxPENSTYLE_LONG_DASH`, `wxPENSTYLE_SHORT_DASH`, `wxPENSTYLE_DOT_DASH`, or `wxPENSTYLE_USER_DASH`.
  | style | The style may be one of the wxPenStyle values.

Remarks:
  Different versions of Windows and different versions of other platforms support very different subsets of the styles above
  - there is no similarity even between Windows95 and Windows98 - so handle with care.

See also:
  SetStyle(), SetColour(), SetWidth()

wxPen::wxPen | ( | const wxBitmap & | stipple,
|  | int | width |
| ) |  |  |

Constructs a stippled pen from a stipple bitmap and a width.

Parameters:

  | width | Pen width. Under Windows, the pen width cannot be greater than 1 if the style is `wxPENSTYLE_DOT`, `wxPENSTYLE_LONG_DASH`, `wxPENSTYLE_SHORT_DASH`, `wxPENSTYLE_DOT_DASH`, or `wxPENSTYLE_USER_DASH`.
  | stipple | A stipple bitmap.

Availability: only available for the wxMSW, wxOSX ports.

See also:
  SetWidth(), SetStipple()

wxPen::wxPen | ( | const wxPen & | pen | ) |

Copy constructor, uses Reference Counting.

Parameters:

  | pen | A pointer or reference to a pen to copy.

virtual wxPen::~wxPen | ( |  | ) | `[virtual]`

Destructor.

See also:
  reference-counted object destruction

Remarks:
  Although all remaining pens are deleted when the application exits, the application should try to clean up all pens itself. This is because wxWidgets cannot know if a pointer to the pen object is stored in an application data structure, and there is a risk of double deletion.

## Member Function Documentation

virtual wxPenCap wxPen::GetCap | ( |  | ) | const`[virtual]`

Returns the pen cap style, which may be one of `wxCAP_ROUND`, `wxCAP_PROJECTING` and `wxCAP_BUTT`.

The default is `wxCAP_ROUND`.

See also:
  SetCap()

virtual wxColour wxPen::GetColour | ( |  | ) | const`[virtual]`

Returns a reference to the pen colour.

See also:
  SetColour()

virtual int wxPen::GetDashes | ( | wxDash ** | dashes | ) | const`[virtual]`

Gets an array of dashes (defined as `char` in X, `DWORD` under Windows).

dashes is a pointer to the internal array. Do not deallocate or store this pointer.

Returns:
  The number of dashes associated with this pen.

See also:
  SetDashes()

virtual wxPenJoin wxPen::GetJoin | ( |  | ) | const`[virtual]`

Returns the pen join style, which may be one of `wxJOIN_BEVEL`, `wxJOIN_ROUND` and `wxJOIN_MITER`.

The default is `wxJOIN_ROUND`.

See also:
  SetJoin()

virtual wxBitmap* wxPen::GetStipple | ( |  | ) | const`[virtual]`

Gets a pointer to the stipple bitmap.

See also:
  SetStipple()

virtual wxPenStyle wxPen::GetStyle | ( |  | ) | const`[virtual]`

Returns the pen style.

See also:
  wxPen(), SetStyle()

virtual int wxPen::GetWidth | ( |  | ) | const`[virtual]`

Returns the pen width.

See also:
  SetWidth()

bool wxPen::IsNonTransparent | ( |  | ) | const

Returns true if the pen is a valid non-transparent pen.

This method returns true if the pen object is initialized and has a non-transparent style. Notice that this should be used instead of simply testing whether GetStyle() returns a style different from wxPENSTYLE_TRANSPARENT if the pen may be invalid as GetStyle() would assert in this case.

See also:
  IsTransparent()

Since:
  2.9.2.

virtual bool wxPen::IsOk | ( |  | ) | const`[virtual]`

Returns true if the pen is initialised.

Notice that an uninitialized pen object can't be queried for any pen properties and all calls to the accessor methods on it will result in an assert failure.

bool wxPen::IsTransparent | ( |  | ) | const

Returns true if the pen is transparent.

A transparent pen is simply a pen with wxPENSTYLE_TRANSPARENT style.

Notice that this function works even for non-initialized pens (for which it returns false) unlike tests of the form `GetStyle() == wxPENSTYLE_TRANSPARENT` which would assert if the pen is invalid.

See also:
  IsNonTransparent()

Since:
  2.9.2.

bool wxPen::operator!= | ( | const wxPen & | pen | ) | const

Inequality operator.

See reference-counted object comparison for more info.

wxPen& wxPen::operator= | ( | const wxPen & | pen | ) |

Assignment operator, using Reference Counting.

bool wxPen::operator== | ( | const wxPen & | pen | ) | const

Equality operator.

See reference-counted object comparison for more info.

virtual void wxPen::SetCap | ( | wxPenCap | capStyle | ) | `[virtual]`

Sets the pen cap style, which may be one of `wxCAP_ROUND`, `wxCAP_PROJECTING` and `wxCAP_BUTT`.

The default is `wxCAP_ROUND`.

See also:
  GetCap()

virtual void wxPen::SetColour | ( | unsigned char | red,
|  | unsigned char | green,
|  | unsigned char | blue |
| ) |  |  | `[virtual]`

The pen's colour is changed to the given colour.

See also:
  GetColour()

virtual void wxPen::SetColour | ( | wxColour & | colour | ) | `[virtual]`

The pen's colour is changed to the given colour.

See also:
  GetColour()

virtual void wxPen::SetDashes | ( | int | n,
|  | const wxDash * | dash |
| ) |  |  | `[virtual]`

Associates an array of pointers to dashes (defined as `char` in X, `DWORD` under Windows) with the pen.

The array is not deallocated by wxPen, but neither must it be deallocated by the calling application until the pen is deleted or this function is called with a NULL array.

See also:
  GetDashes()

virtual void wxPen::SetJoin | ( | wxPenJoin | join_style | ) | `[virtual]`

Sets the pen join style, which may be one of `wxJOIN_BEVEL`, `wxJOIN_ROUND` and `wxJOIN_MITER`.

The default is `wxJOIN_ROUND`.

See also:
  GetJoin()

virtual void wxPen::SetStipple | ( | const wxBitmap & | stipple | ) | `[virtual]`

Sets the bitmap for stippling.

See also:
  GetStipple()

virtual void wxPen::SetStyle | ( | wxPenStyle | style | ) | `[virtual]`

Set the pen style.

See also:
  wxPen()

virtual void wxPen::SetWidth | ( | int | width | ) | `[virtual]`

Sets the pen width.

See also:
  GetWidth()

|  | [ top ]